'****************************************************************************
'
' C-Control/BASIC   ShowAD.BAS
'
' Die Werte der 8 A/D-Wandler im LCD-Display anzeigen
'
' Systemvoraussetzungen:
' - Application Board mit angeschlossenem Display
'
'****************************************************************************

'****************************************************************************
'*   Konstanten                                                             *
'****************************************************************************
'define KONSTANZ &H01

'****************************************************************************
'*   Variablen (Daten). Max. 24 Byte!                                       *
'****************************************************************************
'define EinBit  bit[1]    'ein Bit. bit[1] ... bit[192] = 24 Byte
'define EinByte byte[1]   'ein Byte. byte[1] ... byte[24] = 24 Byte
'define EinWord word[1]   'ein Word. word[1] ... word[12] = 24 Byte
define Parm1    word      'Parameter (Integerwert) fr Unterprogramme
define Parm2    word      'Parameter (Integerwert) fr Unterprogramme
define Hilf1    word      'Hilfsfeld fr diverse Zwecke
define Hilf2    word      'Hilfsfeld fr diverse Zwecke
define i        byte      'Schleifenvariable
define LastSec  byte      'vorheriger Wert von SEKUNDE

'--- LCD Display ------------------------------------------------------------
define lcd_buf   byte
define lcd_param byte

'****************************************************************************
'*   Digitalports                                                           *
'****************************************************************************
define P1  port[1]    'Digitalport  1, Ein-/Ausgabe
define P2  port[2]    'Digitalport  2, Ein-/Ausgabe
define P3  port[3]    'Digitalport  3, Ein-/Ausgabe
define P4  port[4]    'Digitalport  4, Ein-/Ausgabe
define P5  port[5]    'Digitalport  5, Ein-/Ausgabe
define P6  port[6]    'Digitalport  6, Ein-/Ausgabe
define P7  port[7]    'Digitalport  7, Ein-/Ausgabe
define P8  port[8]    'Digitalport  8, Ein-/Ausgabe
define P9  port[9]    'Digitalport  9, Ein-/Ausgabe
define P10 port[10]   'Digitalport 10, Ein-/Ausgabe
define P11 port[11]   'Digitalport 11, Ein-/Ausgabe
define P12 port[12]   'Digitalport 12, Ein-/Ausgabe
define P13 port[13]   'Digitalport 13, Ein-/Ausgabe
define P14 port[14]   'Digitalport 14, Ein-/Ausgabe
define P15 port[15]   'Digitalport 15, Ein-/Ausgabe
define P16 port[16]   'Digitalport 16, Ein-/Ausgabe

'--- 8 Bit breite Digitalports ----------------------------------------------
define BytePort1 byteport[1]   '8 Bit Port 1 (1-8)
define BytePort2 byteport[2]   '8 Bit Port 2 (9-16)

'--- 16 Bit breiter Digitalport ---------------------------------------------
define WordPort1 wordport[1]   '16 Bit Port 1 (1-16)

'****************************************************************************
'*   Analogports                                                            *
'****************************************************************************
define AD1 ad[1]   'Analogport 1, Eingabe
define AD2 ad[2]   'Analogport 2, Eingabe
define AD3 ad[3]   'Analogport 3, Eingabe
define AD4 ad[4]   'Analogport 4, Eingabe
define AD5 ad[5]   'Analogport 5, Eingabe
define AD6 ad[6]   'Analogport 6, Eingabe
define AD7 ad[7]   'Analogport 7, Eingabe
define AD8 ad[8]   'Analogport 8, Eingabe

define DA1 da[1]   'Analogport 1, Ausgabe
define DA2 da[2]   'Analogport 2, Ausgabe

'****************************************************************************
'*   Tastatur-Port                                                          *
'****************************************************************************
define keyboard ad[8]

'****************************************************************************
'*   LCD Display Ports                                                      *
'****************************************************************************
define lcd_port byteport[2]   '8 Bit Port 2 (9-16)
define lcd_rw   port[13]
define lcd_rs   port[14]
define lcd_e    port[15]

'****************************************************************************
'*   Andreas' Magic LCD Display Constants                       Ver. 1.00   *
'*   ------------------------------------                       20.09.1999  *
'*   Aufruf: lcd_param = <konstante> : gosub LCD_WRITECMD                   *
'*   Copyright (c) 1999 Andreas Richau. All rights reserved.                *
'*                                      Alle Rechte vorbehalten.            *
'*   Email: ARichau@provinzial-online.de                                    *
'****************************************************************************
define LCD_CursorOff    &B00001100   'kein Cursor sichtbar
define LCD_CursorOn     &B00001110   'Unterstrich (nicht blinkend)
define LCD_CursorBlock  &B00001101   'groer Block, blinkend
define LCD_CursorLine   &B00001110   'Unterstrich (nicht blinkend)
define LCD_CursorBlink  &B00001111   'Unterstrich/Block, abwechselnd blinkend
define LCD_DisplayOff   &H08         'Display ausschalten
define LCD_DisplayOn    &H0C         'Display einschalten
define LCD_CursorLeft   &H10         'Cursor ein Zeichen nach links
define LCD_CursorRight  &H14         'Cursor ein Zeichen nach rechts
define LCD_DisplayLeft  &H18         'ges. Display ein Zeichen nach links
define LCD_DisplayRight &H1C         'ges. Display ein Zeichen nach rechts

define LCD_GotoLine1    &H80         'Cursor in Zeile 1
define LCD_GotoLine2    &HC0         'Cursor in Zeile 2

define LCD_GotoLine1c1  &H80         'Cursor in Zeile 1, Spalte 1
define LCD_GotoLine1c2  &H81         'Cursor in Zeile 1, Spalte 2
define LCD_GotoLine1c3  &H82         'Cursor in Zeile 1, Spalte 3
define LCD_GotoLine1c4  &H83         'Cursor in Zeile 1, Spalte 4
define LCD_GotoLine1c5  &H84         'Cursor in Zeile 1, Spalte 5
define LCD_GotoLine1c6  &H85         'Cursor in Zeile 1, Spalte 6
define LCD_GotoLine1c7  &H86         'Cursor in Zeile 1, Spalte 7
define LCD_GotoLine1c8  &H87         'Cursor in Zeile 1, Spalte 8
define LCD_GotoLine1c9  &H88         'Cursor in Zeile 1, Spalte 9
define LCD_GotoLine1c10 &H89         'Cursor in Zeile 1, Spalte 10
define LCD_GotoLine1c11 &H8A         'Cursor in Zeile 1, Spalte 11
define LCD_GotoLine1c12 &H8B         'Cursor in Zeile 1, Spalte 12
define LCD_GotoLine1c13 &H8C         'Cursor in Zeile 1, Spalte 13
define LCD_GotoLine1c14 &H8D         'Cursor in Zeile 1, Spalte 14
define LCD_GotoLine1c15 &H8E         'Cursor in Zeile 1, Spalte 15
define LCD_GotoLine1c16 &H8F         'Cursor in Zeile 1, Spalte 16
define LCD_GotoLine1c17 &H90         'Cursor in Zeile 1, Spalte 17
define LCD_GotoLine1c18 &H91         'Cursor in Zeile 1, Spalte 18
define LCD_GotoLine1c19 &H92         'Cursor in Zeile 1, Spalte 19
define LCD_GotoLine1c20 &H93         'Cursor in Zeile 1, Spalte 20
define LCD_GotoLine1c21 &H94         'Cursor in Zeile 1, Spalte 21
define LCD_GotoLine1c22 &H95         'Cursor in Zeile 1, Spalte 22
define LCD_GotoLine1c23 &H96         'Cursor in Zeile 1, Spalte 23
define LCD_GotoLine1c24 &H97         'Cursor in Zeile 1, Spalte 24
define LCD_GotoLine1c25 &H98         'Cursor in Zeile 1, Spalte 25
define LCD_GotoLine1c26 &H99         'Cursor in Zeile 1, Spalte 26
define LCD_GotoLine1c27 &H9A         'Cursor in Zeile 1, Spalte 27
define LCD_GotoLine1c28 &H9B         'Cursor in Zeile 1, Spalte 28
define LCD_GotoLine1c29 &H9C         'Cursor in Zeile 1, Spalte 29
define LCD_GotoLine1c30 &H9D         'Cursor in Zeile 1, Spalte 30
define LCD_GotoLine1c31 &H9E         'Cursor in Zeile 1, Spalte 31
define LCD_GotoLine1c32 &H9F         'Cursor in Zeile 1, Spalte 32
define LCD_GotoLine1c33 &HA0         'Cursor in Zeile 1, Spalte 33
define LCD_GotoLine1c34 &HA1         'Cursor in Zeile 1, Spalte 34
define LCD_GotoLine1c35 &HA2         'Cursor in Zeile 1, Spalte 35
define LCD_GotoLine1c36 &HA3         'Cursor in Zeile 1, Spalte 36
define LCD_GotoLine1c37 &HA4         'Cursor in Zeile 1, Spalte 37
define LCD_GotoLine1c38 &HA5         'Cursor in Zeile 1, Spalte 38
define LCD_GotoLine1c39 &HA6         'Cursor in Zeile 1, Spalte 39
define LCD_GotoLine1c40 &HA7         'Cursor in Zeile 1, Spalte 40

define LCD_GotoLine2c1  &HC0         'Cursor in Zeile 2, Spalte 1
define LCD_GotoLine2c2  &HC1         'Cursor in Zeile 2, Spalte 2
define LCD_GotoLine2c3  &HC2         'Cursor in Zeile 2, Spalte 3
define LCD_GotoLine2c4  &HC3         'Cursor in Zeile 2, Spalte 4
define LCD_GotoLine2c5  &HC4         'Cursor in Zeile 2, Spalte 5
define LCD_GotoLine2c6  &HC5         'Cursor in Zeile 2, Spalte 6
define LCD_GotoLine2c7  &HC6         'Cursor in Zeile 2, Spalte 7
define LCD_GotoLine2c8  &HC7         'Cursor in Zeile 2, Spalte 8
define LCD_GotoLine2c9  &HC8         'Cursor in Zeile 2, Spalte 9
define LCD_GotoLine2c10 &HC9         'Cursor in Zeile 2, Spalte 10
define LCD_GotoLine2c11 &HCA         'Cursor in Zeile 2, Spalte 11
define LCD_GotoLine2c12 &HCB         'Cursor in Zeile 2, Spalte 12
define LCD_GotoLine2c13 &HCC         'Cursor in Zeile 2, Spalte 13
define LCD_GotoLine2c14 &HCD         'Cursor in Zeile 2, Spalte 14
define LCD_GotoLine2c15 &HCE         'Cursor in Zeile 2, Spalte 15
define LCD_GotoLine2c16 &HCF         'Cursor in Zeile 2, Spalte 16
define LCD_GotoLine2c17 &HD0         'Cursor in Zeile 2, Spalte 17
define LCD_GotoLine2c18 &HD1         'Cursor in Zeile 2, Spalte 18
define LCD_GotoLine2c19 &HD2         'Cursor in Zeile 2, Spalte 19
define LCD_GotoLine2c20 &HD3         'Cursor in Zeile 2, Spalte 20
define LCD_GotoLine2c21 &HD4         'Cursor in Zeile 2, Spalte 21
define LCD_GotoLine2c22 &HD5         'Cursor in Zeile 2, Spalte 22
define LCD_GotoLine2c23 &HD6         'Cursor in Zeile 2, Spalte 23
define LCD_GotoLine2c24 &HD7         'Cursor in Zeile 2, Spalte 24
define LCD_GotoLine2c25 &HD8         'Cursor in Zeile 2, Spalte 25
define LCD_GotoLine2c26 &HD9         'Cursor in Zeile 2, Spalte 26
define LCD_GotoLine2c27 &HDA         'Cursor in Zeile 2, Spalte 27
define LCD_GotoLine2c28 &HDB         'Cursor in Zeile 2, Spalte 28
define LCD_GotoLine2c29 &HDC         'Cursor in Zeile 2, Spalte 29
define LCD_GotoLine2c30 &HDD         'Cursor in Zeile 2, Spalte 30
define LCD_GotoLine2c31 &HDE         'Cursor in Zeile 2, Spalte 31
define LCD_GotoLine2c32 &HDF         'Cursor in Zeile 2, Spalte 32
define LCD_GotoLine2c33 &HE0         'Cursor in Zeile 2, Spalte 33
define LCD_GotoLine2c34 &HE1         'Cursor in Zeile 2, Spalte 34
define LCD_GotoLine2c35 &HE2         'Cursor in Zeile 2, Spalte 35
define LCD_GotoLine2c36 &HE3         'Cursor in Zeile 2, Spalte 36
define LCD_GotoLine2c37 &HE4         'Cursor in Zeile 2, Spalte 37
define LCD_GotoLine2c38 &HE5         'Cursor in Zeile 2, Spalte 38
define LCD_GotoLine2c39 &HE6         'Cursor in Zeile 2, Spalte 39
define LCD_GotoLine2c40 &HE7         'Cursor in Zeile 2, Spalte 40

'****************************************************************************
'*   ASCII-Codes                                                            *
'****************************************************************************
define BLANK               &H20   'Zeichen ' '
define LEERZ               &H20   'Zeichen ' '
define char_Rufzeichen     &H21   'Zeichen !
define char_AnfZeichen     &H22   'Zeichen "
define char_Doppelkreuz    &H23   'Zeichen #
define char_Dollar         &H24   'Zeichen $
define char_Prozent        &H25   'Zeichen %
define char_Ampersand      &H26   'Zeichen &
define char_Apostroph      &H27   'Zeichen '
define char_KlammerAuf     &H28   'Zeichen (
define char_KlammerZu      &H29   'Zeichen )
define char_Stern          &H2A   'Zeichen *
define char_Plus           &H2B   'Zeichen +
define char_Komma          &H2C   'Zeichen ,
define char_Minus          &H2D   'Zeichen -
define char_Punkt          &H2E   'Zeichen .
define char_Schraegstrich  &H2F   'Zeichen /
define ziff_0              &H30   'Ziffer 0
define ziff_1              &H31   'Ziffer 1
define ziff_2              &H32   'Ziffer 2
define ziff_3              &H33   'Ziffer 3
define ziff_4              &H34   'Ziffer 4
define ziff_5              &H35   'Ziffer 5
define ziff_6              &H36   'Ziffer 6
define ziff_7              &H37   'Ziffer 7
define ziff_8              &H38   'Ziffer 8
define ziff_9              &H39   'Ziffer 9
define char_Doppelpunkt    &H3A   'Zeichen :
define char_Semikolon      &H3B   'Zeichen ;
define char_KleinerAls     &H3C   'Zeichen <
define char_Gleich         &H3D   'Zeichen =
define char_GroesserAls    &H3E   'Zeichen >
define char_Fragezeichen   &H3F   'Zeichen ?
define a_   &H61
define b_   &H62
define c_   &H63
define d_   &H64
define e_   &H65
define f_   &H66
define g_   &H67
define h_   &H68
define i_   &H69
define j_   &H6A
define k_   &H6B
define l_   &H6C
define m_   &H6D
define n_   &H6E
define o_   &H6F
define p_   &H70
define q_   &H71
define r_   &H72
define s_   &H73
define t_   &H74
define u_   &H75
define v_   &H76
define w_   &H77
define x_   &H78
define y_   &H79
define z_   &H7A
define ae_  &HE1
define oe_  &HEF
define ue_  &HF6
define sz_  &HE2
define AG_  &H41
define BG_  &H42
define CG_  &H43
define DG_  &H44
define EG_  &H45
define FG_  &H46
define GG_  &H47
define HG_  &H48
define IG_  &H49
define JG_  &H4A
define KG_  &H4B
define LG_  &H4C
define MG_  &H4D
define NG_  &H4E
define OG_  &H4F
define PG_  &H50
define QG_  &H51
define RG_  &H52
define SG_  &H53
define TG_  &H54
define UG_  &H55
define VG_  &H56
define WG_  &H57
define XG_  &H58
define YG_  &H59
define ZG_  &H5A
define char_EckKlammAuf    &H5B   'Zeichen [
define char_EckKlammZu     &H5D   'Zeichen ]
define char_Caret          &H5E   'Zeichen ^
define char_Unterstrich    &H5F   'Zeichen _
define char_GeschwKlammAuf &H7B   'Zeichen {
define char_VertStrich     &H7C   'Zeichen |
define char_GeschwKlammZu  &H7D   'Zeichen }
define char_PfeilRechts    &H7E   'Pfeil nach rechts
define char_PfeilLinks     &H7F   'Pfeil nach links
define char_Spot           &HA5   'Zeichen ''
define char_HorStrich      &HB0   'Zeichen ''
define char_Grad           &HDF   'Zeichen 
define char_Mykro          &HE4   'Zeichen 
define char_Unendlich      &HF4   'Zeichen 
define char_Ohm            &HF5   'Zeichen 
define char_Block          &HFF   'Zeichen ''



'****************************************************************************
'*--------------------------------------------------------------------------*
'*   Hauptroutine                                                           *
'*--------------------------------------------------------------------------*
'****************************************************************************
  gosub LCD_INIT

  lcd_param = LCD_GotoLine1c2  : gosub LCD_WRITECMD
  lcd_param = AG_     : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = DG_     : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = ziff_1  : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = LCD_GotoLine1c6  : gosub LCD_WRITECMD
  lcd_param = AG_     : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = DG_     : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = ziff_2  : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = LCD_GotoLine1c10 : gosub LCD_WRITECMD
  lcd_param = AG_     : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = DG_     : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = ziff_3  : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = LCD_GotoLine1c14 : gosub LCD_WRITECMD
  lcd_param = AG_     : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = DG_     : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = ziff_4  : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = LCD_GotoLine2c2  : gosub LCD_WRITECMD
  lcd_param = AG_     : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = DG_     : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = ziff_5  : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = LCD_GotoLine2c6  : gosub LCD_WRITECMD
  lcd_param = AG_     : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = DG_     : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = ziff_6  : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = LCD_GotoLine2c10 : gosub LCD_WRITECMD
  lcd_param = AG_     : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = DG_     : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = ziff_7  : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = LCD_GotoLine2c14 : gosub LCD_WRITECMD
  lcd_param = AG_     : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = DG_     : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = ziff_8  : gosub LCD_WRITECHAR   'Zeichen ausgeben
  pause 150   '3 Sekunde Pause, zum "sehen"

  #MainLoop
  if keyboard < 20 then goto PgmEnde      'Taste '*' gedrckt? ==> Ende
  if Second = LastSec then goto MainLoop  'Schon neue Sekunde angebrochen?
  LastSec = Second                        'Sekunde merken
  ' ----+----1----+-
  '  nnn nnn nnn nnn    
  '  nnn nnn nnn nnn     
  lcd_param = LCD_GotoLine1c2  : gosub LCD_WRITECMD
  parm1 = AD1 : parm2 = 3 : gosub LCD_WRITEVALUERIGHT
  lcd_param = LCD_GotoLine1c6  : gosub LCD_WRITECMD
  parm1 = AD2 : parm2 = 3 : gosub LCD_WRITEVALUERIGHT
  lcd_param = LCD_GotoLine1c10 : gosub LCD_WRITECMD
  parm1 = AD3 : parm2 = 3 : gosub LCD_WRITEVALUERIGHT
  lcd_param = LCD_GotoLine1c14 : gosub LCD_WRITECMD
  parm1 = AD4 : parm2 = 3 : gosub LCD_WRITEVALUERIGHT
  lcd_param = LCD_GotoLine2c2  : gosub LCD_WRITECMD
  parm1 = AD5 : parm2 = 3 : gosub LCD_WRITEVALUERIGHT
  lcd_param = LCD_GotoLine2c6  : gosub LCD_WRITECMD
  parm1 = AD6 : parm2 = 3 : gosub LCD_WRITEVALUERIGHT
  lcd_param = LCD_GotoLine2c10 : gosub LCD_WRITECMD
  parm1 = AD7 : parm2 = 3 : gosub LCD_WRITEVALUERIGHT
  lcd_param = LCD_GotoLine2c14 : gosub LCD_WRITECMD
  parm1 = AD8 : parm2 = 3 : gosub LCD_WRITEVALUERIGHT
  'pause 50   '1 Sekunde Pause, damit das Display nicht so stark flimmert

  goto MainLoop                           'weiter im Text ...

  '*------------------------------------------------------------------------*
  #PgmEnde   'Programmende: Display lschen und 'Ende' ausgeben
  gosub LCD_CLS
  lcd_param = EG_ : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = n_  : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = d_  : gosub LCD_WRITECHAR   'Zeichen ausgeben
  lcd_param = e_  : gosub LCD_WRITECHAR   'Zeichen ausgeben

  end



'****************************************************************************
'*--------------------------------------------------------------------------*
'*   Unterprogramme                                                         *
'*--------------------------------------------------------------------------*
'****************************************************************************



'****************************************************************************
'*   LCD_INIT                                                               *
'*--------------------------------------------------------------------------*
'*   Initialisieren des LCD Displays, Anzeige lschen                       *
'*   keine Parameter                                                        *
'****************************************************************************
#LCD_INIT

  'alle ports 0
  lcd_port = OFF

  '8-Bit-Modus aktivieren
  lcd_param=&H38 : gosub LCD_WRITECMD

  'mit 8-Bit-Command in 4-Bit-Modus umschalten
  lcd_port=&B00000010
  tog lcd_e
  tog lcd_e

  'ab jetzt 4-Bit-Modus
  lcd_param = &H28 : gosub LCD_WRITECMD
  lcd_param = &H0C : gosub LCD_WRITECMD



'****************************************************************************
'*   LCD_CLS                                                                *
'*--------------------------------------------------------------------------*
'*   LCD Anzeige lschen                                                    *
'*                                                                          *
'****************************************************************************
#LCD_CLS
  lcd_param = &H02 : gosub LCD_WRITECMD
  lcd_param = &H01 : gosub LCD_WRITECMD
return



'****************************************************************************
'*   LCD_WRITECMD                                                           *
'*--------------------------------------------------------------------------*
'*   intern: Befehl an LCD Display senden                                   *
'*   Parameter: lcd_param : Kommando                                        *
'****************************************************************************
#LCD_WRITECMD
  lcd_buf = OFF
  goto LCD_WRITE



'****************************************************************************
'*   LCD_WRITECHAR                                                          *
'*--------------------------------------------------------------------------*
'*   Zeichen auf dem Display an der nchsten Position ausgeben              *
'*   Parameter: lcd_param : Zeichen (ASCII)                                 *
'****************************************************************************
#LCD_WRITECHAR
  lcd_buf = &B00100000



'****************************************************************************
'*   LCD_WRITE                                                              *
'*--------------------------------------------------------------------------*
'*   intern: Kommando oder Zeichen an Display senden                        *
'*   Parameter: lcd_param : Zeichen oder Kommando                           *
'****************************************************************************
#LCD_WRITE
  lcd_port = lcd_buf or (lcd_param shr 4) ' Hi-Nibble
  tog lcd_e
  tog lcd_e
  lcd_port = lcd_buf or (lcd_param and &H0F)  ' Lo-Nibble
  tog lcd_e
  tog lcd_e
return



'****************************************************************************
'*   LCD_WRITEVALUE                                                         *
'*   LCD_WRITEVALUEDEC                                                      *
'*--------------------------------------------------------------------------*
'*   Gibt den Inhalt der Variablen 'Parm1' an der aktuellen Position auf    *
'*   dem LCD Display aus. WRITEVALUEDEC gibt den Inhalt der Variablen       *
'*   'Parm1' mit der Anzahl 'Parm2' Nachkommastellen aus.                   *
'*   Parameter: Parm1     = Integerwert                                     *
'*              Parm2     = Anzahl Nachkommastellen (0 bis 4)               *
'*   Variablen: Hilf1     = Zwischenspeicher fr Integerwert                *
'*              lcd_param = Parameter fr Zeichenausgabe                    *
'****************************************************************************
#LCD_WRITEVALUE     'Einsprungadresse, wenn keine Nachkommastellen
  Parm2 = 0

#LCD_WRITEVALUEDEC  'Einsprungadresse fr 'mit Nachkommastellen'

  'negatives Vorzeichen?
  if Parm1 > -1 then goto LCD_WV_10000
  lcd_param = char_Minus : gosub LCD_WRITECHAR   'Zeichen ausgeben

  '-- Zehntausender-Stelle
  #LCD_WV_10000
  Hilf1 = Parm1
  if Parm1 < 10000 and Parm1 > -10000 and Parm2 < 4 then goto LCD_WV_1000   'keine 10000er Stellen?
  lcd_param = ziff_0 + abs( Hilf1 / 10000 ) : gosub LCD_WRITECHAR
  Hilf1 = Hilf1 mod 10000
  if Parm2 <> 4 then goto LCD_WV_1000
  lcd_param = char_Punkt : gosub LCD_WRITECHAR
  
  '-- Tausender-Stelle
  #LCD_WV_1000
  if Parm1 < 1000 and Parm1 > -1000 and Parm2 < 3 then goto LCD_WV_100   'keine 1000er Stellen?
  lcd_param = ziff_0 + abs( Hilf1 / 1000 ) : gosub LCD_WRITECHAR
  Hilf1 = Hilf1 mod 1000
  if Parm2 <> 3 then goto LCD_WV_100
  lcd_param = char_Punkt : gosub LCD_WRITECHAR

  '-- Hunderter-Stelle
  #LCD_WV_100
  if Parm1 < 100 and Parm1 > -100 and Parm2 < 2 then goto LCD_WV_10   'keine 100er Stellen?
  lcd_param = ziff_0 + abs( Hilf1 / 100 ) : gosub LCD_WRITECHAR
  Hilf1 = Hilf1 mod 100
  if Parm2 <> 2 then goto LCD_WV_10
  lcd_param = char_Punkt : gosub LCD_WRITECHAR

  '-- Zehner-Stelle
  #LCD_WV_10
  if Parm1 < 10 and Parm1 > -10 and Parm2 < 1 then goto LCD_WV_1   'keine 10er Stellen?
  lcd_param = ziff_0 + abs( Hilf1 / 10 ) : gosub LCD_WRITECHAR
  Hilf1 = Hilf1 mod 10
  if Parm2 <> 1 then goto LCD_WV_1
  lcd_param = char_Punkt : gosub LCD_WRITECHAR

  '-- Einer-Stelle
  #LCD_WV_1
  lcd_param = ziff_0 + abs( Hilf1 ) : gosub LCD_WRITECHAR

  return



'****************************************************************************
'*   LCD_WRITEVALUERIGHT                                                    *
'*--------------------------------------------------------------------------*
'*   Gibt den Inhalt der Variablen 'Parm1' RECHTSBNDIG an der aktuellen    *
'*   Position mit 'Parm2' Stellen aus.                                      *
'*   Parameter: Parm1 = Integerwert, der ausgegeben werden soll             *
'*              Parm2 = Anzahl Stellen (1 - 6)                              *
'****************************************************************************
#LCD_WRITEVALUERIGHT
  'Hilf1 = Lnge des Ausgabestrings
  Hilf1 = 6
  if Parm1 > -10000                   then Hilf1 = 5
  if Parm1 >  -1000 and Parm1 < 10000 then Hilf1 = 4
  if Parm1 >   -100 and Parm1 <  1000 then Hilf1 = 3
  if Parm1 >    -10 and Parm1 <   100 then Hilf1 = 2
  if Parm1 >     -1 and Parm1 <    10 then Hilf1 = 1
  'Anzahl Leerstellen = Vorgegebene Lnge - Lnge
  Hilf1 = Parm2 - Hilf1
  #LCD_WVR_NEXTBLANK
  if Hilf1 < 1 then goto LCD_WVR_NOBLANKS
  lcd_param = BLANK : gosub LCD_WRITECHAR
  Hilf1 = Hilf1 - 1
  goto LCD_WVR_NEXTBLANK
  #LCD_WVR_NOBLANKS
  gosub LCD_WRITEVALUE
  
  return



'****************************************************************************
'*--------------------------------------------------------------------------*
'*   Tabellen                                                               *
'*--------------------------------------------------------------------------*
'****************************************************************************
'TABLE InDatei "InDatei.tab"   'Externe Tabelle aus einer Datei

'table ImSource                'Interne Tabelle im selben Source-Code
'  1 2 3 4
'  5 6 7 8
'tabend
